tigase.xmpp.impl.push

## Class PushNotifications

- java.lang.Object
- - tigase.xmpp.XMPPProcessor
  - - tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor
    - - tigase.xmpp.impl.push.AbstractPushNotifications
      - - tigase.xmpp.impl.push.PushNotifications

- All Implemented Interfaces:
    Comparable<XMPPImplIfc>, RegistrarBean, OfflineMessages.Notifier, XMPPImplIfc, XMPPProcessorConcurrencyAwareIfc, XMPPProcessorIfc

      @Bean(name="urn:xmpp:push:0",
            parent=SessionManager.class,
            active=true,
            exportable=true)
      public class PushNotifications
      extends AbstractPushNotifications
      implements XMPPProcessorIfc, OfflineMessages.Notifier, RegistrarBean

  Created by andrzej on 30.12.2016.

- - ### Field Summary

    - ### Fields inherited from class tigase.xmpp.impl.push.AbstractPushNotifications

      `ID, maxTimeout, withBody, withSender, XMLNS`

    - ### Fields inherited from class tigase.xmpp.XMPPProcessor

      `ALL_NAMES, ALL_PATHS, cmpInfo`

    - ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

      `CLIENT_XMLNS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PushNotifications()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected Element` | `createSettingsElement(JID jid, String node, Element enableElem, Element optionsForm)`
    `protected boolean` | `isSendingNotificationAllowed(BareJID userJid, XMPPResourceConnection session, Element pushServiceSettings, Packet packet)`
    `void` | `notifyNewOfflineMessage(Packet packet, XMPPResourceConnection session, Queue<Packet> results, Map<String,Object> map)`
    `protected void` | `notifyOfflineMessagesRetrieved(BareJID userJid, Collection<Element> pushServices)`
    `void` | `notifyOfflineMessagesRetrieved(XMPPResourceConnection session, Queue<Packet> results)`
    `protected Element` | `prepareNotificationPayload(Element pushServiceSettings, Packet packet, long msgCount)`
    `void` | `process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository nonAuthUserRepository, Queue<Packet> results, Map<String,Object> map)`
    `protected void` | `processMessage(Packet packet, XMPPResourceConnection session, Consumer<Packet> consumer)`
    `protected void` | `refreshDiscoFeatures()`
    `void` | `register(Kernel kernel)` Method called when bean is being registered allowing developer to programatically register other beans.
    `void` | `setAwares(ArrayList<PushNotificationsAware> awares)`
    `void` | `setFilter(ArrayList<PushNotificationsFilter> filters)`
    `void` | `setTriggers(ArrayList<PushNotificationsExtension> triggers)`
    `protected boolean` | `shouldSendNotification(Packet packet, BareJID userJid, XMPPResourceConnection session)`
    `Element[]` | `supDiscoFeatures(XMPPResourceConnection session)` Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request.
    `void` | `unregister(Kernel kernel)` Method called while bean is being unregistered.

    - ### Methods inherited from class tigase.xmpp.impl.push.AbstractPushNotifications

      `disableNotifications, enableNotifications, enableNotifications, getPushServices, getPushServices, sendPushNotification, sendPushNotification, shouldDisablePush`

    - ### Methods inherited from class tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor

      `id, supElementNamePaths, supNamespaces, supStreamFeatures, supTypes`

    - ### Methods inherited from class tigase.xmpp.XMPPProcessor

      `canHandle, compareTo, concurrentQueuesNo, getComponentInfo, getInstance, getQueueSize, getStatistics, getThreadsNo, init, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

      `canHandle, concurrentQueuesNo, getComponentInfo, getStatistics, id, init, supElementNamePaths, supNamespaces, supStreamFeatures, supTypes`

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

- - ### Constructor Detail

    - #### PushNotifications

          public PushNotifications()

  - ### Method Detail

    - #### supDiscoFeatures

          public Element[] supDiscoFeatures(XMPPResourceConnection session)

      Description copied from interface: `XMPPImplIfc`
      Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request. Service discovery features returned by this method correspond to services supported by this plugin.
      Specified by:
        `supDiscoFeatures` in interface `XMPPImplIfc`
      Overrides:
        `supDiscoFeatures` in class `AnnotatedXMPPProcessor`
      Parameters:
        `session` - a `XMPPResourceConnection` value
      Returns:
        an `Element[]` value

    - #### setAwares

          public void setAwares(ArrayList<PushNotificationsAware> awares)

    - #### setFilter

          public void setFilter(ArrayList<PushNotificationsFilter> filters)

    - #### setTriggers

          public void setTriggers(ArrayList<PushNotificationsExtension> triggers)

    - #### refreshDiscoFeatures

          protected void refreshDiscoFeatures()

    - #### process

          public void process(Packet packet,
                              XMPPResourceConnection session,
                              NonAuthUserRepository nonAuthUserRepository,
                              Queue<Packet> results,
                              Map<String,Object> map)
                       throws XMPPException

      Specified by:
        `process` in interface `XMPPProcessorIfc`
      Overrides:
        `process` in class `AbstractPushNotifications`
      Parameters:
        `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
        `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
        `nonAuthUserRepository` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
        `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
        `map` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
      Throws:
        `XMPPException`

    - #### processMessage

          protected void processMessage(Packet packet,
                                        XMPPResourceConnection session,
                                        Consumer<Packet> consumer)
                                 throws NotAuthorizedException,
                                        TigaseDBException

      Overrides:
        `processMessage` in class `AbstractPushNotifications`
      Throws:
        `NotAuthorizedException`
        `TigaseDBException`

    - #### notifyNewOfflineMessage

          public void notifyNewOfflineMessage(Packet packet,
                                              XMPPResourceConnection session,
                                              Queue<Packet> results,
                                              Map<String,Object> map)

      Specified by:
        `notifyNewOfflineMessage` in interface `OfflineMessages.Notifier`

    - #### notifyOfflineMessagesRetrieved

          public void notifyOfflineMessagesRetrieved(XMPPResourceConnection session,
                                                     Queue<Packet> results)

      Specified by:
        `notifyOfflineMessagesRetrieved` in interface `OfflineMessages.Notifier`

    - #### register

          public void register(Kernel kernel)

      Description copied from interface: `RegistrarBean`
      Method called when bean is being registered allowing developer to programatically register other beans.
      Specified by:
        `register` in interface `RegistrarBean`
      Parameters:
        `kernel` - - instance from local scope

    - #### unregister

          public void unregister(Kernel kernel)

      Description copied from interface: `RegistrarBean`
      Method called while bean is being unregistered.
      Specified by:
        `unregister` in interface `RegistrarBean`
      Parameters:
        `kernel` - - instance from local scope

    - #### createSettingsElement

          protected Element createSettingsElement(JID jid,
                                                  String node,
                                                  Element enableElem,
                                                  Element optionsForm)

      Overrides:
        `createSettingsElement` in class `AbstractPushNotifications`

    - #### notifyOfflineMessagesRetrieved

          protected void notifyOfflineMessagesRetrieved(BareJID userJid,
                                                        Collection<Element> pushServices)

    - #### prepareNotificationPayload

          protected Element prepareNotificationPayload(Element pushServiceSettings,
                                                       Packet packet,
                                                       long msgCount)

      Overrides:
        `prepareNotificationPayload` in class `AbstractPushNotifications`

    - #### isSendingNotificationAllowed

          protected boolean isSendingNotificationAllowed(BareJID userJid,
                                                         XMPPResourceConnection session,
                                                         Element pushServiceSettings,
                                                         Packet packet)

      Overrides:
        `isSendingNotificationAllowed` in class `AbstractPushNotifications`

    - #### shouldSendNotification

          protected boolean shouldSendNotification(Packet packet,
                                                   BareJID userJid,
                                                   XMPPResourceConnection session)

Copyright © 2004–2021 "Tigase, Inc.". All rights reserved.